drawscreen
overscan
 lda INTIM ;wait for sync
 bne overscan
;do VSYNC
 lda #2
 sta WSYNC
 sta VSYNC
 STA WSYNC
 STA WSYNC
 LDA #0
 STA WSYNC
 STA VSYNC
 sta VBLANK
 lda #37
 sta TIM64T

; position player 0
 lda player0x
 ldx #0
 ldy player0y
 jsr playerset

; position player 1
 lda player1x
 ldx #1
 ldy player1y
 jsr playerset

; position missile 0
 lda missile0x
 ldx #2
 ldy missile0y
 jsr playerset

; position missile 1
 lda missile1x
 ldx #3
 ldy missile1y
 jsr playerset

; position ball
 lda ballx
 ldx #4
 ldy bally
 jsr playerset

;set score pointers
 lda score+2
 jsr scorepointerset
 sty scorepointers+10
 stx scorepointers+8
 lda score+1
 jsr scorepointerset
 sty scorepointers+6
 stx scorepointers+4
 lda score
 jsr scorepointerset
 sty scorepointers+2
 stx scorepointers

vblk
 LDA INTIM
 bne vblk
 jmp kernel

game
